<?php
/**
 * Image signature Limit 1.1
 * by Kimi - <kimi@mybboard.it> 
 * http://www.mybboard.it
 *
 */
 
// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("usercp_start", "siglimit");

function siglimit_info()
{
 global $lang;
 $lang->load("siglimit");
 
	return array(
		"name"			=> $lang->siglimit_title,
		"description"	=> $lang->siglimit_desc,
		"website"		=> "http://mybboard.it",
		"author"		=> "Kimi",
		"authorsite"	=> "http://mybboard.it",
		"version"		=> "1.1",
		"guid" 			=> "695e2a8d05bee6d10abaa3a8dbdad10f",
		"compatibility" => "14*"
	);
}

function siglimit_install()
{
 global $mybb, $db, $lang;
 
 $lang->load("siglimit");
 
 //Delete duplicate
 $db->delete_query("settings", "name = 'sigimg_width'");
 $db->delete_query("settings", "name = 'sigimg_height'");
 
 $query = $db->simple_select("settinggroups", "gid", "name = 'member'");
 $gid = $db->fetch_field($query, "gid");
 
 	$insertarray = array(
		'name'        => 'sigimg_width',
		'title'       => $db->escape_string($lang->width_limit_title),
		'description' => $db->escape_string($lang->width_limit_desc),
		'optionscode' => 'text',
		'value'       => 500,
		'disporder'   => 50,
		'gid'         => $gid,
		'isdefault'   => 0
	);
	$db->insert_query("settings", $insertarray);
	
	
	$insertarray = array(
		'name'        => 'sigimg_height',
		'title'       => $db->escape_string($lang->height_limit_title),
		'description' => $db->escape_string($lang->height_limit_desc),
		'optionscode' => 'text',
		'value'       => 100,
		'disporder'   => 51,
		'gid'         => $gid,
		'isdefault'   => 0
	);
	$db->insert_query("settings", $insertarray);

	rebuild_settings();
}

function siglimit_is_installed()
{
 global $db;
 
 $query  = $db->simple_select("settings", "*", "name = 'sigimg_width'");
 $result = $db->num_rows($query);
 
 if($result)
 {
   return true;
 }
 
 return false;
}

function siglimit_uninstall()
{
 global $db;
 
 $db->delete_query("settings", "name = 'sigimg_width'");
 $db->delete_query("settings", "name = 'sigimg_height'");
 
 rebuild_settings();
 
}

function siglimit()
{
 global $mybb, $lang, $error, $parser;
 
 if($mybb->input['action'] == "do_editsig" && $mybb->request_method == "post") 
 {
 
    $lang->load("siglimit");
  
 	$parser_options = array(
		'allow_html' => $mybb->settings['sightml'],
		'filter_badwords' => 1,
		'allow_mycode' => $mybb->settings['sigmycode'],
		'allow_smilies' => $mybb->settings['sigsmilies'],
		'allow_imgcode' => $mybb->settings['sigimgcode'],
		"filter_badwords" => 1
	);
	$parsed_sig = $parser->parse_message($mybb->input['signature'], $parser_options);
	
	preg_match_all("#<img src=\"(.*?)\" (.*?)/>#", $parsed_sig, $matches, PREG_SET_ORDER);


	
	foreach ($matches as $img)
	{
	
	   $size = getimagesize($img[1]);
	   
	   if($size[0] > $mybb->settings['sigimg_width'])
	   {
	   
	   $lang->too_large = $lang->sprintf($lang->too_large, $img[1], $size[0], $mybb->settings['sigimg_width']);
	   $error[] = $lang->too_large;
	   
	   }
	   
	   if($size[1] > $mybb->settings['sigimg_height'])
	   {
	   
	   $lang->too_high = $lang->sprintf($lang->too_high, $img[1], $size[1], $mybb->settings['sigimg_height']);
	   $error[] = $lang->too_high;
	   
	   }
	 
	}
	
	if($error)
	{
	 
	 $error = inline_error($error);
	 
	}
 
 }

}
?>